﻿using Infragistics.Controls.Menus;
using Infragistics.Windows;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Globalization;

namespace DataTreeSelectionWidth
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            OtherTree.ItemsSource = new SampleData();
        }

        public Node UpdateNodeCheckedState(Node node)
        {
            if (node.Children.Count != 0)
            {
                if (node.IsChecked)
                {
                    foreach (var childNode in node.Children)
                    {
                        if (childNode.NodeType == Node.Type.C)
                        {
                            return node;
                        }
                        else
                        {
                            childNode.IsChecked = true;
                            UpdateNodeCheckedState(childNode);
                        }
                    }
                }

                if (node.IsChecked == false)
                {
                    foreach (var childNode in node.Children)
                    {
                        if (childNode.NodeType == Node.Type.C)
                        {
                            return node;
                        }
                        else
                        {
                            childNode.IsChecked = false;
                            UpdateNodeCheckedState(childNode);
                        }
                    }
                }
            }
            return node;
        }

        public bool CheckChildNodeCheckedState(Node node)
        {
            bool hasCheckedChildrenInHierarchy = false;

            if (node.Children.Count != 0)
            {
                foreach (var childNode in node.Children)
                {
                    if(childNode.IsChecked)
                    {
                        hasCheckedChildrenInHierarchy = true;
                        CheckChildNodeCheckedState(childNode);
                    }
                }
            }


            return hasCheckedChildrenInHierarchy;
        }

        public XamDataTreeNodeControl UpdateParentNodeCheckedState(XamDataTreeNodeControl node)
        {
            XamDataTreeNodeDataContext nodeDataContext = (XamDataTreeNodeDataContext)node.DataContext;


            if (node.Node.Manager.ParentNode != null)
            {
                var parentNode = node.Node.Manager.ParentNode;
                var parentNodeData = (parentNode.Data as Node);

                if (((((XamDataTreeNodeDataContext)node.DataContext).Data) as Node).IsChecked)
                {
                        parentNodeData.IsChecked = true;

                }
                if (((((XamDataTreeNodeDataContext)node.DataContext).Data) as Node).IsChecked == false)
                {
                    if ((nodeDataContext.Data as Node).NodeType != Node.Type.C)
                    {
                        parentNodeData.IsChecked = false;
                    }
                    else return node;
                }

                return node;
            }
            else return node;
        }

        private void CheckBox_Checked(object sender, RoutedEventArgs e)
        {
            XamDataTreeNodeControl node = Utilities.GetAncestorFromType(sender as DependencyObject, typeof(XamDataTreeNodeControl), true) as XamDataTreeNodeControl;
            XamDataTreeNodeDataContext nodeDataContext = (XamDataTreeNodeDataContext)node.DataContext;

            UpdateNodeCheckedState(nodeDataContext.Data as Node);
            UpdateParentNodeCheckedState(node);

            var templatedNode = nodeDataContext.Data as Node;

            if (templatedNode.NodeType == Node.Type.C)
            {

            }
        }
    }

    public class SampleData : ObservableCollection<Node>
    {
        public SampleData()
        {
            Node p1 = new Node { Name = "Parent1", Children = new ObservableCollection<Node>(),   NodeType = Node.Type.A};
            Node pc1 = new Node { Name = "child1", Children = new ObservableCollection<Node>(),   NodeType = Node.Type.B};
            Node pcc1 = new Node { Name = "child1a", Children = new ObservableCollection<Node>(), NodeType = Node.Type.C};

            p1.Children.Add(pc1);
            pc1.Children.Add(pcc1);

            this.Add(p1);

            Node p2 = new Node { Name = "Parent2", Children = new ObservableCollection<Node>(),     NodeType = Node.Type.A};
            Node p2c1 = new Node { Name = "child1a", Children = new ObservableCollection<Node>(),   NodeType = Node.Type.B};
            Node p2cc1 = new Node { Name = "child1a1", Children = new ObservableCollection<Node>(), NodeType = Node.Type.C};

            p2.Children.Add(p2c1);
            p2c1.Children.Add(p2cc1);

            this.Add(p2);

            //ParentNode p1 = new ParentNode { Name = "Profitability", Children = new ObservableCollection<ChildNode>() };
            //ParentNode p2 = new ParentNode { Name = "Growth", Children = new ObservableCollection<ChildNode>() };
            //ParentNode p3 = new ParentNode { Name = "Efficiency", SubParents = new ObservableCollection<ParentNode>(), Children = new ObservableCollection<ChildNode>() };
            //ParentNode p4 = new ParentNode { Name = "Investment", Children = new ObservableCollection<ChildNode>() };
            //ParentNode p5 = new ParentNode { Name = "Capital Strength", Children = new ObservableCollection<ChildNode>() };
            //ParentNode p6 = new ParentNode { Name = "Quality", Children = new ObservableCollection<ChildNode>() };
            //ParentNode p7 = new ParentNode { Name = "Upwards", Children = new ObservableCollection<ChildNode>() };

            //p1.Children.Add(new ChildNode() { Parent = p1, Name = "1", Value = 1});
            //p2.Children.Add(new ChildNode() { Parent = p2, Name = "2", Value = 2});
            //p4.Children.Add(new ChildNode() { Parent = p4, Name = "3", Value = 3});
            //p5.Children.Add(new ChildNode() { Parent = p5, Name = "4", Value = 4});
            //p6.Children.Add(new ChildNode() { Parent = p6, Name = "5", Value = 5});

            //p7.Children.Add(new ChildNode { Parent = p7, Name = "Days sales outstanding", Value = 1, Average = 64.3, StandardDeviation = 32.6, Percent = 1.0 });
            //p7.Children.Add(new ChildNode { Parent = p7, Name = "Days payables outstanding", Value = 1, Average = 70.8, StandardDeviation = 84.2, Percent = 0.8 });
            //p7.Children.Add(new ChildNode { Parent = p7, Name = "Inventory turnover, days", Value = 1, Average = 6.4, StandardDeviation = 15.3, Percent = 0.7 });
            //p7.Children.Add(new ChildNode { Parent = p7, Name = "NWI / Sales", Value = 1, Average = 0.1, StandardDeviation = 0.1, Percent = 0.9 });
            //p7.Children.Add(new ChildNode { Parent = p7, Name = "Asset turnover", Value = 1, Average = 0.7, StandardDeviation = 0.3, Percent = 0.0 });
            //p3.SubParents.Add(p7);

            //this.Add(p1);
            //this.Add(p2);
            //this.Add(p7);
            //this.Add(p4);
            //this.Add(p5);
            //this.Add(p6);
        }
    }

    public class ThreeStateConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            XamDataTreeNodeDataContext nodeContext = value as XamDataTreeNodeDataContext;

            return nodeContext.Node.HasChildren;
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            return new NotImplementedException();
        }
    }

    public class Node : ObservableModel
    {
        public enum Type
        {
            A, B, C
        }

        public string Name { get; set; }

        //public ObservableCollection<ParentNode> SubParents { get; set; }

        public ObservableCollection<Node> Children { get; set; }

        public bool? IsSelected { get; set; }

        private bool _isChecked;

        public Type NodeType {get; set;}

        public bool IsChecked
        {
            get { return _isChecked; }
            set
            {
                _isChecked = value;
                OnPropertyChanged("IsChecked");
            }
        }
    }

    //public class ChildNode : ObservableModel
    //{
    //    public string Name { get; set; }

    //    public double Value { get; set; }

    //    public double Average { get; set; }

    //    public double StandardDeviation { get; set; }

    //    public double Percent { get; set; }

    //    public bool? IsSelected { get; set; }

    //    public bool IsChecked
    //    {
    //        get { return _isChecked; }
    //        set { _isChecked = value;
    //            Parent.IsChecked = _isChecked;
    //            OnPropertyChanged("IsChecked");
    //        }
    //    }

    //    private bool _isChecked;

    //    public Node Parent { get; set; }
    //}

    public class ObservableModel : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;

        protected void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
